var _excluded = ["rowStyle", "data", "columns", "disableHeaders", "isLoading", "hasError", "isEmpty", "initialSortBy", "initialSelectedRowIds", "renderEmpty", "renderError", "numberOfLoadingRows", "expandable", "onlyOneExpanding", "isRowExpandable", "isRowSelectable", "onSortBy", "onRowClick", "onRowSelect", "className", "pageSize", "GlobalFilter", "globalFilterProps", "filterFunction", "bordered", "onRowMove", "disableRowSelect", "showSelectAllInHeader", "selectedCountKey", "disableSelectAll", "autoResetExpanded", "autoResetPage", "selectAllKey", "clearAllKey", "allSelectedOnPageKey", "allSelectedKey", "wrapperStyle", "getRowId"];

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useMemo, useEffect, useState, useRef, Fragment } from 'react';
import { useTable, useFlexLayout, useSortBy, useExpanded, useRowSelect, usePagination, useGlobalFilter } from 'react-table';
import { variables as theme } from '@cloudflare/style-const';
import { applyStaticStyles } from '@cloudflare/style-container';
import { Trans } from '@cloudflare/intl-react';
import { Div, Span } from '@cloudflare/elements';
import { Link } from '@cloudflare/component-link';
import { Icon } from '@cloudflare/component-icon';
import { Checkbox } from '@cloudflare/component-checkbox';
import { Pagination } from '@cloudflare/component-pagination';
import { SortableContainer, SortableElement, arrayMove } from 'react-sortable-hoc';
import DragHandle from './DragHandle';
import MoveRowButtons from './MoveRowButtons';
import { List, AutoSizer, CellMeasurer, CellMeasurerCache } from 'react-virtualized';
import useMeasure from 'react-use-measure';
import { ResizeObserver as ResizeObserverPolyfill } from '@juggle/resize-observer';
var ResizeObserver = window.ResizeObserver || ResizeObserverPolyfill;
import { DefaultCell } from './CellStyles';
import HeaderRow from './HeaderRow';
import Row from './Row';
var SortableList = SortableContainer(List);
var SortableRow = SortableElement(Row);
var borderColor = theme.colors.gray[7];
export var EXPANDABLE_ID = 'expandable-id';
export var SELECTABLE_ID = 'selectable-id';
export var DRAGGABLE_ID = 'draggable-id';
var defaultScrollHeight = 700;
var count = 0;
var ScrollWrapper = applyStaticStyles("\n  .ReactVirtualized__List {\n    outline: none\n  }\n  .cf-table-row-drag {\n    pointer-events: auto !important;\n    z-index: 2000 !important;\n    box-shadow: 0 0 10px rgba(0, 0, 0, 0.2) !important;\n    background-color: ".concat(theme.colors.background, " !important;\n  }\n  .cf-table-row-drag * {\n    cursor: grabbing !important;\n  }\n  "), Div);
export var isRowActions = columnId => [EXPANDABLE_ID, SELECTABLE_ID, DRAGGABLE_ID].includes(columnId);
var draggableColumn = {
  id: DRAGGABLE_ID,
  width: 50,
  Cell: _ref => {
    var _row$original, _row$getRowProps, _column$isDragHandleV;

    var {
      row,
      rows,
      column,
      columns,
      allColumns
    } = _ref;
    var rowId = "table_".concat(column.getTableId(), "_row").concat(((_row$original = row.original) === null || _row$original === void 0 ? void 0 : _row$original.id) || ((_row$getRowProps = row.getRowProps()) === null || _row$getRowProps === void 0 ? void 0 : _row$getRowProps.key));
    var indexOffset = allColumns.length - columns.length;
    return /*#__PURE__*/React.createElement(DefaultCell, {
      px: 2,
      justifyContent: "center"
    }, ((_column$isDragHandleV = column.isDragHandleVisible) === null || _column$isDragHandleV === void 0 ? void 0 : _column$isDragHandleV.call(column)) && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(DragHandle, null), /*#__PURE__*/React.createElement(MoveRowButtons, {
      handleMoveUpClick: row.index > 0 ? () => column.moveRow(rows, {
        oldIndex: row.index,
        newIndex: row.index - 1
      }) : undefined,
      handleMoveDownClick: row.index < rows.length - 1 ? () => {
        column.moveRow(rows, {
          oldIndex: row.index,
          newIndex: row.index + 1
        });
      } : undefined,
      describedBy: columns.map((_col, index) => "".concat(rowId, "_cell_").concat(indexOffset + index))
    })));
  }
}; // @ts-ignore

draggableColumn.Cell.displayName = 'DraggableColumnCell';
var expandableColumn = {
  id: EXPANDABLE_ID,
  width: 26,
  Cell: _ref2 => {
    var {
      row
    } = _ref2;
    return /*#__PURE__*/React.createElement(DefaultCell, {
      px: 1,
      style: _objectSpread(_objectSpread({}, row.isExpanded ? {
        transform: 'rotate(90deg)'
      } : {}), {}, {
        transition: 'transform 0.18s ease-out'
      })
    }, /*#__PURE__*/React.createElement(Icon, {
      type: "right",
      label: ""
    }));
  }
}; // @ts-ignore

expandableColumn.Cell.displayName = 'ExpandableColumnCell';
var selectableColumn = {
  id: SELECTABLE_ID,
  Header: _ref3 => {
    var _column$getCellData;

    var {
      rows,
      column,
      pageRows,
      isRowSelectable,
      selectAllKey
    } = _ref3;
    // If table is paginated, page contains only the visible rows
    var selectableRows = (pageRows || rows).filter(row => !isRowSelectable || isRowSelectable(row));
    var selectedRows = selectableRows.filter(row => row.isSelected);
    var [isChecked, setIsChecked] = useState(selectedRows.length > 0);
    var isIndeterminate = selectedRows.length > 0 && selectedRows.length < selectableRows.length;
    useEffect(() => {
      setIsChecked(selectedRows.length > 0);
    }, [selectedRows]);

    var handleToggleAll = () => {
      var selectedValue = !isChecked;
      setIsChecked(selectedValue);
      return selectableRows.forEach(row => row.toggleRowSelected(selectedValue));
    };

    return /*#__PURE__*/React.createElement(Div, {
      display: "flex",
      alignItems: "flex-start",
      mt: "2px"
    }, /*#__PURE__*/React.createElement(Checkbox, {
      name: "toggleAll",
      onChange: handleToggleAll,
      checked: isChecked,
      indeterminate: isIndeterminate,
      disabled: !selectableRows.length || ((_column$getCellData = column.getCellData) === null || _column$getCellData === void 0 ? void 0 : _column$getCellData.call(column).disableRowSelect),
      value: "true",
      label: ""
    }), !!selectAllKey && /*#__PURE__*/React.createElement(Span, {
      ml: 3
    }, /*#__PURE__*/React.createElement(Trans, {
      id: selectAllKey
    })));
  },
  Cell: _ref4 => {
    var _column$getCellData2;

    var {
      row,
      column,
      isRowSelectable
    } = _ref4;
    var isDisabled = isRowSelectable && !isRowSelectable(row) || ((_column$getCellData2 = column.getCellData) === null || _column$getCellData2 === void 0 ? void 0 : _column$getCellData2.call(column).disableRowSelect);
    return /*#__PURE__*/React.createElement(DefaultCell, {
      alignItems: "flex-start",
      pr: 0,
      pt: 2
    }, /*#__PURE__*/React.createElement(Checkbox, _extends({
      name: "toggleRow",
      onClick: e => e.stopPropagation()
    }, row.getToggleRowSelectedProps(), isDisabled ? {
      checked: false
    } : {}, {
      // Force checked = false if disabled
      disabled: isDisabled,
      value: "true",
      label: ""
    })));
  }
}; // @ts-ignore

selectableColumn.Header.displayName = 'SelectableColumnHeader'; // @ts-ignore

selectableColumn.Cell.displayName = 'SelectableColumnCell';
var defaultColumn = {
  width: 50,
  Cell: _ref5 => {
    var {
      cell: {
        value
      }
    } = _ref5;
    return /*#__PURE__*/React.createElement(DefaultCell, null, value);
  }
}; // @ts-ignore

defaultColumn.Cell.displayName = 'DefaultStyleColumnCell';

var defaultComponent = () => /*#__PURE__*/React.createElement(Fragment, null);

var defaultNoop = () => {};

var defaultWrapperStyle = {
  position: 'relative',
  borderBottom: "1px solid ".concat(borderColor)
};

var Table = _ref6 => {
  var {
    rowStyle,
    data,
    columns,
    disableHeaders,
    isLoading,
    hasError,
    isEmpty,
    initialSortBy = [],
    initialSelectedRowIds = {},
    renderEmpty: Empty = defaultComponent,
    renderError: Error = defaultComponent,
    numberOfLoadingRows = 10,
    expandable,
    onlyOneExpanding,
    isRowExpandable,
    isRowSelectable,
    onSortBy = defaultNoop,
    onRowClick = defaultNoop,
    onRowSelect,
    className,
    pageSize,
    GlobalFilter,
    globalFilterProps,
    filterFunction,
    bordered,
    onRowMove,
    disableRowSelect,
    showSelectAllInHeader,
    selectedCountKey,
    disableSelectAll = false,
    autoResetExpanded,
    autoResetPage,
    selectAllKey = 'common.table.select_all',
    clearAllKey = 'common.table.clear_all',
    allSelectedOnPageKey = 'common.table.all_selected_on_page',
    allSelectedKey = 'common.table.all_selected',
    wrapperStyle = defaultWrapperStyle,
    getRowId
  } = _ref6,
      wrapperProps = _objectWithoutProperties(_ref6, _excluded);

  var listRef = useRef();
  var canMoveRows = !!(onRowMove && data && (data === null || data === void 0 ? void 0 : data.length) > 0);
  var [tableId] = useState(() => ++count);
  var dragState = useMemo(() => ({
    canDrag: true
  }), []);
  var [cellData] = useState({
    disableRowSelect
  });
  cellData.disableRowSelect = disableRowSelect;
  var memoizedData = useMemo(() => isLoading ? Array.from({
    length: numberOfLoadingRows
  }, () => ({})) : [...(data !== null && data !== void 0 ? data : [])], [data, isLoading, numberOfLoadingRows]);
  var [reorderableData, setReorderableData] = useState(memoizedData);
  useEffect(() => setReorderableData(memoizedData), [memoizedData]);
  var memoizedColumns = useMemo(() => columns.map(column => _objectSpread(_objectSpread({}, column), {}, {
    disableSortBy: !column.enableSortBy
  })), [columns]);

  if ([GlobalFilter, filterFunction].filter(item => item).length === 1) {
    console.error('Both GlobalFilter and filterFunction must be specified together');
  }

  var cellMeasurerCache = useMemo(() => new CellMeasurerCache({
    // TODO prop
    minHeight: 37,
    fixedWidth: true
  }), []); // Use the cellMeasurer cache to determine the size of table when using
  // virtual scrolling.

  var scrollHeight = 0;

  if (onRowMove && pageSize) {
    for (var ii = 0; ii < pageSize; ++ii) {
      var _cellMeasurerCache$_r;

      // @ts-ignore
      scrollHeight += ((_cellMeasurerCache$_r = cellMeasurerCache._rowHeightCache) === null || _cellMeasurerCache$_r === void 0 ? void 0 : _cellMeasurerCache$_r["".concat(ii, "-0")]) || 0;
    }
  }

  scrollHeight = scrollHeight || defaultScrollHeight;
  var {
    getTableProps,
    getTableBodyProps,
    gotoPage,
    headerGroups,
    rows,
    page,
    prepareRow,
    // @ts-ignore
    state: {
      sortBy,
      selectedRowIds,
      pageIndex,
      globalFilter
    },
    canPreviousPage,
    canNextPage,
    previousPage,
    nextPage,
    preGlobalFilteredRows,
    setGlobalFilter: _setGlobalFilter,
    toggleAllRowsSelected,
    toggleAllRowsExpanded
  } = useTable({
    data: canMoveRows ? reorderableData : memoizedData,
    columns: memoizedColumns,
    defaultColumn,
    manualSortBy: true,
    disableMultiSort: true,
    autoResetExpanded: !!autoResetExpanded,
    autoResetPage: !!autoResetPage,
    initialState: {
      sortBy: initialSortBy,
      selectedRowIds: initialSelectedRowIds,
      pageSize
    },
    globalFilter: filterFunction,
    // @ts-ignore
    getRowId
  }, useFlexLayout, ...(GlobalFilter ? [useGlobalFilter] : []), useSortBy, useExpanded, useRowSelect, ...(pageSize ? [usePagination] : []), hooks => {
    if (onRowSelect) {
      hooks.visibleColumns.push(columns => [_objectSpread(_objectSpread({}, selectableColumn), {}, {
        width: showSelectAllInHeader ? 120 : 34,
        isRowSelectable,
        getCellData: () => cellData
      }), ...columns]);
    }

    if (canMoveRows) {
      hooks.visibleColumns.push(columns => [_objectSpread(_objectSpread({}, draggableColumn), {}, {
        isDragHandleVisible: () => dragState.canDrag,
        getTableId: () => tableId,
        moveRow: (rowsToUpdate, _ref7) => {
          var {
            newIndex,
            oldIndex
          } = _ref7;
          var updatedData = arrayMove(rowsToUpdate.map(row => row.original), oldIndex, newIndex);
          setReorderableData(updatedData);
          onRowMove === null || onRowMove === void 0 ? void 0 : onRowMove(updatedData, {
            newIndex,
            oldIndex
          });
        }
      }), ...columns]);
    }

    if (expandable) {
      hooks.visibleColumns.push(columns => [expandableColumn, ...columns]);
    }
  });
  useEffect(() => {
    if (!onRowSelect || isLoading) return;
    var rowObjects = Object.keys(selectedRowIds).reduce((acc, rId) => {
      var rawRow = (preGlobalFilteredRows || rows).find(_ref8 => {
        var {
          id
        } = _ref8;
        return rId === id;
      });
      if (!rawRow) return acc;
      if (isRowSelectable && !isRowSelectable(rawRow)) return acc;
      return [...acc, _objectSpread({
        rowIndex: rawRow.index
      }, rawRow.original)];
    }, []);
    onRowSelect(rowObjects);
  }, [selectedRowIds, isLoading]);
  useEffect(() => {
    onSortBy(sortBy);
  }, [sortBy]);
  useEffect(() => {
    cellMeasurerCache === null || cellMeasurerCache === void 0 ? void 0 : cellMeasurerCache.clearAll();
  }, [columns, data]);
  var [ref, {
    width: containerWidth
  }] = useMeasure({
    polyfill: ResizeObserver
  });
  var selectedRowsCount = Object.keys(selectedRowIds).length;
  var allSelected = selectedRowsCount === rows.length;
  var pageSelected = !!pageSize && page.every(row => row.isSelected);
  var filtered = !!preGlobalFilteredRows && preGlobalFilteredRows.length !== rows.length;
  var showSelectAll = !!selectedRowsCount && pageSelected;
  return /*#__PURE__*/React.createElement(Div, wrapperProps, !!GlobalFilter && /*#__PURE__*/React.createElement(GlobalFilter, _extends({
    rows: rows,
    preGlobalFilteredRows: preGlobalFilteredRows,
    globalFilter: globalFilter,
    selectedRowsCount: selectedRowsCount,
    toggleAllRowsSelected: toggleAllRowsSelected,
    setGlobalFilter: filter => {
      dragState.canDrag = !filter;

      if (!!pageSize) {
        gotoPage(0);
      }

      _setGlobalFilter(filter);
    }
  }, globalFilterProps || {})), /*#__PURE__*/React.createElement("div", {
    ref: ref,
    className: className,
    style: _objectSpread(_objectSpread({}, bordered ? {
      border: "1px solid ".concat(borderColor)
    } : {}), wrapperStyle)
  }, /*#__PURE__*/React.createElement(Div, getTableProps(), /*#__PURE__*/React.createElement(HeaderRow, {
    disableHeaders: disableHeaders,
    headerGroups: headerGroups,
    isLoading: isLoading,
    isEmpty: isEmpty,
    hasError: hasError,
    selectAllKey: showSelectAllInHeader ? selectAllKey : undefined
  }), (showSelectAll || selectedCountKey) && !disableRowSelect && !disableSelectAll && /*#__PURE__*/React.createElement(Div, {
    backgroundColor: "gray.9",
    textAlign: "center",
    padding: 2,
    borderRadius: 2,
    borderBottom: "1px solid",
    borderColor: borderColor
  }, /*#__PURE__*/React.createElement(Trans, {
    id: selectedCountKey || (allSelected ? allSelectedKey : allSelectedOnPageKey),
    smartCount: !selectedCountKey && pageSize && !allSelected ? page.filter(row => row.isSelected).length : selectedRowsCount
  }), /*#__PURE__*/React.createElement(Link, {
    pl: 3,
    onClick: e => {
      e.preventDefault();
      toggleAllRowsSelected(!allSelected);
    }
  }, /*#__PURE__*/React.createElement(Trans, {
    id: allSelected ? clearAllKey : selectAllKey
  }))), /*#__PURE__*/React.createElement(Div, getTableBodyProps(), (!isLoading && isEmpty || filtered && !rows.length) && /*#__PURE__*/React.createElement(Empty, {
    globalFilter: globalFilter
  }), !isLoading && hasError && /*#__PURE__*/React.createElement(Error, null), (!isEmpty || !hasError) && (!filtered && canMoveRows ? /*#__PURE__*/React.createElement(ScrollWrapper, {
    style: {
      height: scrollHeight + 'px'
    }
  }, /*#__PURE__*/React.createElement(AutoSizer, null, _ref9 => {
    var {
      width
    } = _ref9;
    return /*#__PURE__*/React.createElement(SortableList, {
      ref: listRef,
      deferredMeasurementCache: cellMeasurerCache,
      rowHeight: cellMeasurerCache.rowHeight,
      height: scrollHeight,
      rowCount: rows.length,
      width: width,
      rowRenderer: _ref10 => {
        var _row$getRowProps2;

        var {
          index,
          style,
          parent
        } = _ref10;
        var row = rows[index];
        prepareRow(row); // Use row.original.id as key instead of row.getRowProps()?.key to fix the bug causing by index shiftting
        // ex: row.original.id => 911874bcebe89ca25c0d9e415de7f634, row.getRowProps()?.key => row_0

        var rowId = "table_".concat(tableId, "_row").concat(row.original.id || ((_row$getRowProps2 = row.getRowProps()) === null || _row$getRowProps2 === void 0 ? void 0 : _row$getRowProps2.key));
        return /*#__PURE__*/React.createElement(CellMeasurer, {
          cache: cellMeasurerCache,
          columnIndex: 0,
          key: "sortable-row-".concat(rowId),
          parent: parent,
          rowIndex: index
        }, /*#__PURE__*/React.createElement(SortableRow, {
          row: row,
          rowId: rowId,
          index: index,
          rowIndex: index,
          style: style,
          rowStyle: _objectSpread(_objectSpread({}, rowStyle), style),
          isLoading: isLoading,
          striped: false,
          rowHighlight: false,
          onRowClick: onRowClick,
          containerWidth: containerWidth,
          disabled: isRowSelectable && !isRowSelectable(row) || disableRowSelect
        }));
      },
      lockAxis: "y",
      helperClass: "cf-table-row-drag",
      useDragHandle: true,
      onSortEnd: _ref11 => {
        var {
          newIndex,
          oldIndex
        } = _ref11;
        cellMeasurerCache.clearAll();
        var updatedData = arrayMove(reorderableData, oldIndex, newIndex);
        setReorderableData(updatedData);
        onRowMove === null || onRowMove === void 0 ? void 0 : onRowMove(updatedData, {
          newIndex,
          oldIndex
        });
      }
    });
  })) : (page || rows).map((row, i) => {
    var _row$getRowProps3;

    prepareRow(row); // Use row.original.id as key instead of row.getRowProps()?.key to fix the bug causing by index shiftting
    // ex: row.original.id => 911874bcebe89ca25c0d9e415de7f634, row.getRowProps()?.key => row_0

    var rowId = "table_".concat(tableId, "_row").concat(row.original.id || ((_row$getRowProps3 = row.getRowProps()) === null || _row$getRowProps3 === void 0 ? void 0 : _row$getRowProps3.key));
    return /*#__PURE__*/React.createElement(Row, {
      key: rowId,
      testId: "row_".concat(row.original.id),
      row: row,
      rowIndex: i,
      rowId: rowId,
      rowStyle: rowStyle,
      expandable: expandable,
      isRowExpandable: isRowExpandable,
      isRowSelectable: isRowSelectable,
      onlyOneExpanding: onlyOneExpanding,
      toggleAllRowsExpanded: toggleAllRowsExpanded,
      isLoading: isLoading,
      striped: false,
      rowHighlight: false,
      onRowClick: onRowClick,
      containerWidth: containerWidth,
      disabled: isRowSelectable && !isRowSelectable(row)
    });
  })))), !onRowMove && !!pageSize && rows.length > pageSize && /*#__PURE__*/React.createElement(Div, {
    borderTop: bordered ? 'none' : '1px solid',
    borderColor: borderColor
  }, /*#__PURE__*/React.createElement(Pagination, {
    p: 2,
    loading: isLoading,
    start: pageIndex * pageSize + 1,
    end: Math.min(pageIndex * pageSize + pageSize, rows.length),
    total: rows.length,
    onPrevClick: previousPage,
    onNextClick: nextPage,
    disablePreviousButton: !canPreviousPage,
    disableNextButton: !canNextPage
  }))));
};

export default Table;