"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _elements = require("@cloudflare/elements");

var _Table = require("./Table");

var _CellStyles = require("./CellStyles");

var _componentLoading = require("@cloudflare/component-loading");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var Cell = function Cell(_ref) {
  var cell = _ref.cell,
      id = _ref.id,
      isLoading = _ref.isLoading,
      isExpandable = _ref.isExpandable,
      isRowSelectable = _ref.isRowSelectable;
  if (isLoading && !(0, _Table.isRowActions)(cell.column.id)) return /*#__PURE__*/_react.default.createElement(_elements.Div, _extends({
    id: id
  }, cell.getCellProps({
    style: {
      display: 'flex'
    }
  })), /*#__PURE__*/_react.default.createElement(_CellStyles.DefaultCell, null, /*#__PURE__*/_react.default.createElement(_componentLoading.SkeletonBlock, {
    height: "16px",
    width: "".concat(Math.floor(Math.random() * (90 - 20 + 1)) + 20, "%")
  })));
  if (cell.column.id === _Table.EXPANDABLE_ID && !isExpandable) return /*#__PURE__*/_react.default.createElement(_elements.Div, _extends({
    id: id
  }, cell.getCellProps({
    style: {
      display: 'flex',
      flex: '0 0 auto'
    }
  })), /*#__PURE__*/_react.default.createElement(_CellStyles.DefaultCell, null));
  if (cell.column.id === _Table.SELECTABLE_ID || cell.column.id === _Table.EXPANDABLE_ID) return /*#__PURE__*/_react.default.createElement(_elements.Div, _extends({
    id: id
  }, cell.getCellProps({
    style: {
      flex: '0 0 auto',
      display: 'flex',
      alignItems: 'center'
    }
  })), cell.render('Cell', {
    isRowSelectable: isRowSelectable
  }));
  return /*#__PURE__*/_react.default.createElement(_elements.Div, _extends({
    id: id
  }, cell.getCellProps({
    style: {
      display: 'flex',
      alignItems: 'center'
    }
  })), cell.render('Cell'));
};

var _default = Cell;
exports.default = _default;